"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pluralize = require("pluralize");
var dbRepo_1 = require("./dbRepo");
var _ = require("lodash");
function processChildren(obj, entity, embedPlural) {
    return __awaiter(this, void 0, void 0, function () {
        var nestedKey, criteria, objToReturn, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    nestedKey = pluralize(entity, 1);
                    criteria = {};
                    criteria[nestedKey + "Id"] = obj.id;
                    objToReturn = _.cloneDeep(obj);
                    _a = objToReturn;
                    _b = embedPlural;
                    return [4 /*yield*/, dbRepo_1.db.list(embedPlural, criteria)];
                case 1:
                    _a[_b] = _c.sent();
                    return [2 /*return*/, objToReturn];
            }
        });
    });
}
function processParent(obj, embedSingular, embedPlural) {
    return __awaiter(this, void 0, void 0, function () {
        var idName, entity, objToReturn;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    idName = embedSingular + "Id";
                    if (!obj[idName]) return [3 /*break*/, 2];
                    return [4 /*yield*/, dbRepo_1.db.findById(embedPlural, obj[idName])];
                case 1:
                    entity = _a.sent();
                    if (entity) {
                        objToReturn = _.cloneDeep(obj);
                        objToReturn[embedSingular] = entity;
                        delete objToReturn[idName];
                        return [2 /*return*/, objToReturn];
                    }
                    _a.label = 2;
                case 2: return [2 /*return*/, obj];
            }
        });
    });
}
function processEmbedded(obj, entity, embed) {
    return __awaiter(this, void 0, void 0, function () {
        var embedSingular, embedPlural;
        return __generator(this, function (_a) {
            embedSingular = pluralize(embed, 1);
            embedPlural = pluralize(embed, 2);
            if (embed == embedSingular) {
                return [2 /*return*/, processParent(obj, embedSingular, embedPlural)];
            }
            return [2 /*return*/, processChildren(obj, entity, embedPlural)];
        });
    });
}
exports.processEmbedded = processEmbedded;
//# sourceMappingURL=embed.js.map