#! /usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = require("./config");
var log_1 = require("./log");
var express = require("express");
var bodyParser = require("body-parser");
var Bluebird = require("bluebird");
var http = require("http");
require("./router");
var router_1 = require("./router");
var logger = log_1.logFactory("index");
var app = express();
app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json());
app.use(router_1.default);
exports.server = http.createServer(app);
exports.startPromise = Bluebird.fromCallback(function (cb) {
    exports.server.listen(config_1.default.port, function (error) {
        logger.info("started [port: " + config_1.default.port + "]");
        cb(error);
    });
});
//# sourceMappingURL=index.js.map