"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var dbRepo_1 = require("./dbRepo");
var pluralize = require("pluralize");
var embed_1 = require("./embed");
var log_1 = require("./log");
var express = require("express");
var logger = log_1.logFactory("router"), router = express.Router();
router.get("/", function (req, res) {
    res.json({ status: "ok" }).end();
});
router.post("/:entity", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var entity, obj;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entity = pluralize(req.params["entity"], 2);
                return [4 /*yield*/, dbRepo_1.db.save(entity, req.body)];
            case 1:
                obj = _a.sent();
                logger.debug(entity + " created [id: " + obj.id + "]");
                res.status(201).json(obj).end();
                return [2 /*return*/];
        }
    });
}); });
router.get("/:entity/:id", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var entity, id, obj;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entity = pluralize(req.params["entity"], 2);
                id = req.params["id"];
                logger.debug(entity + " get [id: " + id + "]");
                return [4 /*yield*/, dbRepo_1.db.findById(entity, id)];
            case 1:
                obj = _a.sent();
                if (!obj) {
                    res.status(404).end();
                    return [2 /*return*/];
                }
                if (!req.query.embed) return [3 /*break*/, 3];
                return [4 /*yield*/, embed_1.processEmbedded(obj, entity, req.query.embed)];
            case 2:
                obj = _a.sent();
                _a.label = 3;
            case 3:
                res.status(200).json(obj).end();
                return [2 /*return*/];
        }
    });
}); });
router.get("/:entity", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var entity, list;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entity = pluralize(req.params["entity"], 2);
                return [4 /*yield*/, dbRepo_1.db.list(entity, req.query)];
            case 1:
                list = _a.sent();
                logger.debug(entity + " get all");
                res.status(200).json(list).end();
                return [2 /*return*/];
        }
    });
}); });
router.head("/:entity", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var entity, count;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entity = pluralize(req.params["entity"], 2);
                return [4 /*yield*/, dbRepo_1.db.count(entity, req.query)];
            case 1:
                count = _a.sent();
                logger.debug(entity + " count [" + count + "]");
                res.send("" + count).end;
                return [2 /*return*/];
        }
    });
}); });
router.delete("/:entity/:id", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
    var entity, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                entity = pluralize(req.params["entity"], 2);
                id = req.params["id"];
                logger.debug(entity + " delete [id: " + id + "]");
                return [4 /*yield*/, dbRepo_1.db.remove(entity, id)];
            case 1:
                _a.sent();
                res.status(204).end();
                return [2 /*return*/];
        }
    });
}); });
exports.default = router;
//# sourceMappingURL=router.js.map